package RanieriApp;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.text.ParseException;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import Utilities.Commons;

/**
 * @author Michele Ranieri
 * @modifiche Graziella Cipolletti
 */

public class A1 extends Commons{
	
	public void eseguiA1() throws IOException{

		//Crea 'partizioni' come insieme di vettori, uno per ogni coppia di frasi
		//Ogni vettore conterr tutte le decisioni che si riferiscono alla stessa coppia di frasi 
		Hashtable<String,Vector<Decisione>> partizioni=new Hashtable<String,Vector<Decisione>>();
		
		//Prende come file di input tutti quelli contenuti nella directory Base
		/*
		 * File[] baseFiles=new File("Base").listFiles();
		for(int i=0;i<baseFiles.length;i++){
			Decisione.parseFile(baseFiles[i],partizioni);
		}*/
		
		/*
		 * Cipolletti
		 * 
		 */
		
		Commons.matrDecisions=null;
		Commons.matrDecisions=new HashMap<String, Vector<String>>();
		
		System.out.println("Totale File:"+Commons.fV.size());
		Commons.filterNomeContenuto();
		System.out.println("File dopo rimozione:"+Commons.fV.size());
		
		File[] baseFiles=new File[Commons.fV.size()];
		for(int y=0;y<Commons.fV.size();y++)baseFiles[y]=Commons.fV.elementAt(y);
		
	
		for(int i=0;i<baseFiles.length;i++){
			boolean check=Decisione.parseFile(baseFiles[i],partizioni);
			if(!check)
			{
				System.out.println(baseFiles[i].getAbsolutePath()+" NO RANDOM SORT");
			}
			
		}
		
		stampaTutto(partizioni);
		
		
		/*
		 * Ranieri
		 * creaFileM (partizioni, "FMF.txt", "FME.txt");
		*/
		/*
		 * Cipolletti
		 */
		creaFileM (partizioni, Commons.MF.getAbsolutePath(), Commons.ME.getAbsolutePath());
	}
	

	//Crea i due file FM (per le decisioni in cui la moda del campo decision  ben definita)
	// e FE (per le decisioni in cui la moda del campo decision non  definita))
	public void creaFileM(Hashtable<String,Vector<Decisione>> partizioni, String fileMF,String fileME)throws IOException{
		
		PrintStream ME = new PrintStream (new FileOutputStream (new File (fileME)));

		//vettore ordinato con le decisioni da scrivere in MF
		Vector<Decisione> MFv=new Vector<Decisione>();
		
		//il rappresentante di ogni vettore, uno per ogni coppia di frasi
		Decisione rappresentante;
		
		//vettori di date, delle quali calcoleremo la media
		Vector<GregorianCalendar>initDateV;
		Vector<GregorianCalendar>decDateV;
		
		//tutti i diversi valori di decision incontrati, e le loro occorrenze
		Hashtable<String, Integer> valoriDiDecision;
		
		Enumeration<Vector<Decisione>> e = partizioni.elements() ;
		while(e.hasMoreElements()){ //per ogni vettore di decisioni in partizioni
			Vector<Decisione> v = e.nextElement();
			initDateV=new Vector<GregorianCalendar>();
			decDateV=new Vector<GregorianCalendar>();
			valoriDiDecision=new Hashtable<String,Integer>();
			
			Enumeration<Decisione>e2=v.elements();
			Decisione d=null;
			while(e2.hasMoreElements()){ //per ogni decisione nel vettore
				d=e2.nextElement();
				initDateV.addElement(d.getInitDate());
				decDateV.addElement(d.getDecDate());
				
				String campoDecision=d.getDecision().toLowerCase(); // Unrelated  equivalente a unrelated o UNRELATED 
				
				Integer q=valoriDiDecision.get(campoDecision);
				if(q!=null){
					valoriDiDecision.put(campoDecision, new Integer(q.intValue()+1));
				}else{
					valoriDiDecision.put(campoDecision, new Integer(1));
				}
					
			}
			rappresentante=new Decisione();
			//copia i campi Inclusion, Similarity ecc.
			rappresentante.setF1(d.getIdF1(), d.getNameF1(), d.getTextF1(), d.getNwF1());
			rappresentante.setF2(d.getIdF2(), d.getNameF2(), d.getTextF2(), d.getNwF2());
			rappresentante.setInclusion(d.getInclusion());
			rappresentante.setProbInclusion(d.getProbInclusion());
			rappresentante.setSimilarity(d.getSimilarity());
			rappresentante.setProbSimilarity(d.getProbSimilarity());
			
			rappresentante.setInitDate(Decisione.dataMedia(initDateV));
			rappresentante.setDecDate(Decisione.dataMedia(decDateV));
			if(valoriDiDecision.size()==1){
				//se c' un solo valore di decision, questo  la moda
				rappresentante.setDecision(d.getDecision());
				Decisione.aggiungiOrdinato(MFv,rappresentante);
			}else{
				
				Enumeration<String> e3;
				
				//calcola la moda
				String moda1=""; int occorrenze1=0; //valore di decision pi frequente
				e3=valoriDiDecision.keys();
				while (e3.hasMoreElements()){
					String key=e3.nextElement();
					int occorrenze=valoriDiDecision.get(key).intValue();
					if (occorrenze>occorrenze1){ 
						occorrenze1=occorrenze;
						moda1=new String(key);
					}
				}
				
				//calcola il secondo valore pi frequente
				valoriDiDecision.remove(moda1);

				//String moda2=""; //non ci interessa il suo valore, ma solo quante volte occorre
				int occorrenze2=0; //secondo valore di decision pi frequente
				e3=valoriDiDecision.keys();
				while (e3.hasMoreElements()){
					String key2=e3.nextElement();
					int occorrenze=valoriDiDecision.get(key2).intValue();
					if (occorrenze>occorrenze2){ 
						occorrenze2=occorrenze;
						//moda2=new String(key2);
					}
				}

				//se moda non  ben definita
				if(occorrenze1==occorrenze2){
					rappresentante.setDecision(occorrenze1+"");
					
					//scrivo direttamente nel file FME
					ME.println(rappresentante.toString());
					
				}else { //se moda  ben definita
					rappresentante.setDecision(moda1);
					
					//Scrivo in un vettore ordinato, che poi scriver nel file
					Decisione.aggiungiOrdinato(MFv,rappresentante);
					
				}
						
			}
						
		}
		
		ME.close();
		System.out.println("Creato il file "+fileME);

		PrintStream MF = new PrintStream (new FileOutputStream (new File (fileMF)));

		//Scrive il vettore ordinato nel file
		for (int i=0;i<MFv.size();i++){
			MF.println(MFv.get(i).toString());
		}
			
		MF.close();
		System.out.println("Creato il file "+fileMF);


	}

	/**
	 * 
	 * Metodo che mostra come scorrere l'insieme partizioni per accedere 
	 * alle classi di equivalenza e alle singole decisioni
	 * 
	 * */
	public void stampaTutto(Hashtable<String,Vector<Decisione>> partizioni){
		
		int nDecisioni,nClassi=0;
		Enumeration<Vector<Decisione>> e = partizioni.elements() ;
		while(e.hasMoreElements()){
			nClassi++;
			Vector<Decisione> v = e.nextElement();
			Enumeration<Decisione>e2=v.elements();
			nDecisioni=0;
			while(e2.hasMoreElements()){
				nDecisioni++;
				Decisione d=e2.nextElement();
			//	System.out.println(d.toString());
			}
		//	System.out.println("Nuova classe, decisioni: "+nDecisioni);
		}
	//	System.out.println("Numero di classi di equivalenza: "+nClassi);
	
	}
	
	/**
	 * verifica il corretto funzionamento del metodo dataMedia. si pu eliminare
	 * */
	public void testMediaDate(){
		int year, month, date, hour, minute,second;
		year=2008;
		month=9;
		date=20;
		hour=13;
		minute=20;
		second=2;
		GregorianCalendar initDate=new GregorianCalendar(year, month, date, hour, minute,second);
		GregorianCalendar finalDate=new GregorianCalendar(year, month, date, hour, minute+20,second);
		
		Vector<GregorianCalendar>v=new Vector<GregorianCalendar>();
		v.addElement(initDate);
		v.addElement(finalDate);

		Decisione d=new Decisione();

		GregorianCalendar dataMedia=Decisione.dataMedia(v);

		System.out.println("Init  = "+d.stampaData(initDate));
		System.out.println("Final = "+d.stampaData(finalDate));
		System.out.println("Media = "+d.stampaData(dataMedia));

	}
}
