package Utilities;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import Controller.A1Controller;
import Controller.A2Controller;
import RanieriApp.Decisione;


/**
 * @author Graziella Cipolletti
 */

@SuppressWarnings("unchecked")
public abstract class Commons {

	protected static final String ALERT1 = "Il file esiste gi. Vuoi sovrascriverlo?";
	protected static final String ALERT2 = "La sovrascrittura non  stata autorizzata. Scegli un altro file.";
	protected static final String ALERT3 = "File di output gi scelto. Vuoi sostituirlo?";
	protected static final String ALERT4 = "File non settato.";
	protected static final String ALERT5 = "Il path specificato non  valido";
	protected static final String ALERT6 = "File di Input gi selezionato.";
	protected static final String ALERT7 = "Seleziona almeno un file di Input.";
	
	protected static final String fileSep = System.getProperty("file.separator");

	protected static Vector <File> fV=new Vector();
	
	//per verificare duplicati coppie stesso soggetto
	protected static HashMap<String,Vector<String>> matrDecisions;	
	
	// A1
	protected static A1Controller A1C=new A1Controller();
	protected static File MF=null;
	protected static File ME=null;
	
	//A2
	protected static A2Controller A2C=new A2Controller();
    protected static File N=null;
	protected static File FREF=null;
	
	protected static final String userDir = System.getProperty("user.dir");
	protected static String fref_F1=userDir+fileSep+"Req1LogSimilarity.txt";
	protected static String fref_F2=userDir+fileSep+"Req2LogSimilarity.txt";
	

	public static boolean addInputFile(File file) {
			
		if(!fV.contains(file))
		{
			fV.addElement(file);
			return true;
		}
		
		return false;
	}


//	Restituisce una stringa con la data c in formato dd/mm/yyyy||hh.mm.ss
	public static String stampaData2(GregorianCalendar c){
		int year, month, date, hour, minute,second;

		year=c.get(Calendar.YEAR);
		month=c.get(Calendar.MONTH)+1;
		date=c.get(Calendar.DATE);
		hour=c.get(Calendar.HOUR_OF_DAY);
		minute=c.get(Calendar.MINUTE);
		second=c.get(Calendar.SECOND);
		
		String res= ((date<10?"0":"")+ date+"/"+ (month<10?"0":"")+month+"/"+year+Decisione.SEPARATORE+
				(hour<10?"0":"")+hour+":"+ (minute<10?"0":"")+minute+":"+ (second<10?"0":"")+second);
		
		//System.out.printf("Anno=%d Mese=%d Giorno=%d Ora=%d Minuto=%d Secondo=%d Res=%s%n",year,month,date,hour,minute,second,res);
		
		return res;
	}


	public static void filterNomeContenuto() throws IOException {
		
		
//		elimino file per cui nome contenuto non  lo stesso
		for(int y=0;y<Commons.fV.size();y++)
		{
			
			Vector id=new Vector();
			Vector idfRef=new Vector();
			boolean check=true;
			
			File file=Commons.fV.elementAt(y);
			
			FileInputStream fis=new FileInputStream(file);
			InputStreamReader isr=new InputStreamReader(fis);
			BufferedReader br=new BufferedReader(isr);
			
			String riga=br.readLine();
			while(riga!=null)
			{
				
				if(riga.trim().endsWith("!"))
				{
						riga+=br.readLine();
				}
				else if(!riga.contains("{"))
				{
						riga=br.readLine();
				}
				else
				{
					if(riga.contains("! "))
						{
						riga=riga.replaceAll("! ", "");
						}
					
					if(riga.contains("﻿"))
					{
						riga=riga.replaceAll("﻿", "");
					}
					
			
					String[]campi=riga.split("\\|\\|");
					String id1=campi[2].substring(1,campi[2].length()-1);
					String id2=campi[6].substring(1,campi[6].length()-1);
					
					if(!id.contains(id1))id.addElement(id1);
					if(!id.contains(id2))id.addElement(id2);
			
					riga=br.readLine();
				}
			}//while
			
			br.close();
			isr.close();
			fis.close();
			
			if(file.getName().contains("f1") || file.getName().contains("F1"))
			{
			fis=new FileInputStream(Commons.fref_F1);
			}
			else if(file.getName().contains("f2") || file.getName().contains("F2"))
			{
			fis=new FileInputStream(Commons.fref_F2);
			}
		
			isr=new InputStreamReader(fis);
			br=new BufferedReader(isr);
			
			riga=br.readLine();
			while(riga!=null)
			{
					String[]campi=riga.split("\\|\\|");
					String id1=campi[2].substring(1,campi[2].length()-1);
					String id2=campi[6].substring(1,campi[6].length()-1);
					
					if(!idfRef.contains(id1))idfRef.addElement(id1);
					if(!idfRef.contains(id2))idfRef.addElement(id2);
			
					riga=br.readLine();
				
			}//while
		
		br.close();
		isr.close();
		fis.close();
		
		
		//verifico che gli id ci siano tutti, altrimenti cancello i file
		
		for(int h=0;h<idfRef.size();h++)
		{
			String temp=(String) idfRef.elementAt(h);
			
			if(!id.contains(temp)){
				check=false;
				}
		}
		
		
		if(!check)
		{
			//rimuovo il file
			Commons.fV.remove(file);
			System.out.println("--> Rimosso:"+file.getName());
			y--;
		}
		
		
		
	    }//for

		
	}
}
