package Visual;

import java.io.File;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Text;

import Utilities.Commons;

/**
 * @author Graziella Cipolletti
 */

public class E2Panel extends Commons{

	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private Display display;
	private Composite composite = null;
	private TabFolder tabFolder = null;
	private Group A1group = null;
	private Group A2group = null;
	private Group INputgroup = null;
	private Label label = null;
	private Button InputButton = null;
	private Button ClearInputButton = null;
	private Text InputTextArea = null;
	private Text InputText = null;
	private Group OutputGroup = null;
	private Label label1 = null;
	private Label labelMF = null;
	private Label labelME = null;
	private Text MFtext = null;
	private Text MEtext = null;
	private Button BrowseMFbutton = null;
	private Button BrowseMEbutton = null;
	private Group group = null;
	private Button A1button = null;
	private Group groupFileInput = null;
	private Group Inputgroup1 = null;
	private Label label2 = null;
	private Text FREFtext = null;
	private Button FREFbutton = null;
	private Group Outputgroup1 = null;
	private Text Ntext = null;
	private Button Nbutton = null;
	private Label label3 = null;
	private Group group1 = null;
	private Button RUNA2button = null;
	public E2Panel(Display display)
	{
		this.display = display;
		
		createSShell();
		
		sShell.pack();
		sShell.open();
		
		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		
		
	}
	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		sShell = new Shell();
		sShell.setText("Decisions Tools");
		createComposite();
		sShell.setSize(new Point(587, 574));
		sShell.setLayout(new GridLayout());
	}
	/**
	 * This method initializes composite	
	 *
	 */
	private void createComposite() {
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.verticalAlignment = GridData.FILL;
		composite = new Composite(sShell, SWT.NONE);
		composite.setLayout(new GridLayout());
		createGroupFileInput();
		createTabFolder();
		composite.setLayoutData(gridData);
	}
	/**
	 * This method initializes tabFolder	
	 *
	 */
	private void createTabFolder() {
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.grabExcessVerticalSpace = true;
		gridData1.verticalAlignment = GridData.FILL;
		tabFolder = new TabFolder(composite, SWT.NONE);
		tabFolder.setLayoutData(gridData1);
		createA1group();
		createA2group();
		TabItem tabItem = new TabItem(tabFolder, SWT.NONE);
		tabItem.setText("A1");
		tabItem.setControl(A1group);
		TabItem tabItem1 = new TabItem(tabFolder, SWT.NONE);
		tabItem1.setText("A2");
		tabItem1.setControl(A2group);
	}
	/**
	 * This method initializes A1group	
	 *
	 */
	private void createA1group() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		A1group = new Group(tabFolder, SWT.NONE);
		A1group.setLayout(gridLayout);
		createOutputGroup();
		createGroup();
	}
	/**
	 * This method initializes A2group	
	 *
	 */
	private void createA2group() {
		A2group = new Group(tabFolder, SWT.NONE);
		A2group.setLayout(new GridLayout());
		createInputgroup1();
		createOutputgroup1();
		createGroup1();
	}
	/**
	 * This method initializes INputgroup	
	 *
	 */
	private void createINputgroup() {
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.grabExcessVerticalSpace = false;
		gridData3.verticalAlignment = GridData.FILL;
		GridData gridData5 = new GridData();
		gridData5.horizontalAlignment = GridData.BEGINNING;
		gridData5.verticalAlignment = GridData.CENTER;
		GridData gridData4 = new GridData();
		gridData4.horizontalSpan = 3;
		gridData4.verticalAlignment = GridData.FILL;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.verticalSpan = 17;
		gridData4.grabExcessVerticalSpace = false;
		gridData4.horizontalAlignment = GridData.FILL;
		GridData gridData2 = new GridData();
		gridData2.horizontalSpan = 3;
		GridLayout gridLayout1 = new GridLayout();
		gridLayout1.numColumns = 3;
		INputgroup = new Group(groupFileInput, SWT.NONE);
		INputgroup.setText("Input");
		INputgroup.setLayoutData(gridData3);
		INputgroup.setLayout(gridLayout1);
		label = new Label(INputgroup, SWT.NONE);
		label.setText("Selezionare File in Input");
		label.setLayoutData(gridData2);
		label.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		InputTextArea = new Text(INputgroup, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER | SWT.H_SCROLL);
		InputTextArea.setEditable(false);
		InputTextArea.setLayoutData(gridData4);
		InputButton = new Button(INputgroup, SWT.NONE);
		InputButton.setText("Browse Input");
		InputButton.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD | SWT.ITALIC));
		InputText = new Text(INputgroup, SWT.BORDER);
		InputText.setVisible(false);
		InputButton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				System.out.println("BROWSE INPUT"); // TODO Auto-generated Event stub widgetSelected()
				 FileDialog dlg = new FileDialog(sShell,SWT.MULTI);
			        // Set the initial filter path according
			        // to anything they've selected or typed in
			        dlg.setFilterPath(InputText.getText());
			        // Change the title bar text
			        dlg.setText("Select Input File");
			        // Calling open() will open and run the dialog.
			        // It will return the selected directory, or
			        // null if user cancels
			     	   
			        String dir = dlg.open();
			        if (dir != null) {
			        	String[] dirs = dlg.getFileNames();
					    
			        	String path=dlg.getFilterPath();
			        	
			        	String listaFile="";
			        	
			        	for(int i=0;i<dirs.length;i++)
			        	{
			        		String f=path+Commons.fileSep+dirs[i];
			        		if(Commons.addInputFile(new File(f)))
				        	{
				        	listaFile+=f+"\n";
				        	}
				        	else
				        	{
				        		printAlert(Commons.ALERT6);
				        	}
			        	}
			        	// Set the text box to the new selection
			        	InputTextArea.setText(listaFile);
			        	
			        	
			         dir=null;
			        InputText.setText("");
			        }  
			}
		});
		ClearInputButton = new Button(INputgroup, SWT.NONE);
		ClearInputButton.setText("Clear Input");
		ClearInputButton.setLayoutData(gridData5);
		ClearInputButton.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD | SWT.ITALIC));
		ClearInputButton
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						System.out.println("CLEAR INPUT"); 
					InputTextArea.setText("");
					Commons.fV.removeAllElements();
					}
				});
	}
	/**
	 * This method initializes OutputGroup	
	 *
	 */
	private void createOutputGroup() {
		GridData gridData9 = new GridData();
		gridData9.horizontalAlignment = GridData.FILL;
		gridData9.grabExcessHorizontalSpace = true;
		gridData9.verticalAlignment = GridData.CENTER;
		GridData gridData8 = new GridData();
		gridData8.horizontalAlignment = GridData.FILL;
		gridData8.grabExcessHorizontalSpace = true;
		gridData8.verticalAlignment = GridData.CENTER;
		GridData gridData7 = new GridData();
		gridData7.horizontalSpan = 2;
		GridLayout gridLayout2 = new GridLayout();
		gridLayout2.numColumns = 3;
		GridData gridData6 = new GridData();
		gridData6.horizontalAlignment = GridData.FILL;
		gridData6.grabExcessHorizontalSpace = true;
		gridData6.grabExcessVerticalSpace = false;
		gridData6.verticalAlignment = GridData.CENTER;
		OutputGroup = new Group(A1group, SWT.NONE);
		OutputGroup.setLayoutData(gridData6);
		OutputGroup.setLayout(gridLayout2);
		OutputGroup.setText("Output");
		label1 = new Label(OutputGroup, SWT.NONE);
		label1.setText("Selezionare File di Output");
		label1.setLayoutData(gridData7);
		label1.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		Label filler1 = new Label(OutputGroup, SWT.NONE);
		labelMF = new Label(OutputGroup, SWT.NONE);
		labelMF.setText("MF:");
		labelMF.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		MFtext = new Text(OutputGroup, SWT.BORDER);
		MFtext.setLayoutData(gridData8);
		MFtext.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
			Commons.MF=null;
			}
		});
		BrowseMFbutton = new Button(OutputGroup, SWT.NONE);
		BrowseMFbutton.setText("Browse");
		BrowseMFbutton.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD | SWT.ITALIC));
		BrowseMFbutton
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						System.out.println("BROWSE OUTPUT MF"); // TODO Auto-generated Event stub widgetSelected()
						MFtext.setText("");
						Commons.MF=null;
						FileDialog dlg = new FileDialog(sShell);
					        // Set the initial filter path according
					        // to anything they've selected or typed in
					        dlg.setFilterPath(MFtext.getText());
					        // Change the title bar text
					        dlg.setText("Select Output MF File");
					        // Calling open() will open and run the dialog.
					        // It will return the selected directory, or
					        // null if user cancels
					        String dir = dlg.open();
					        if (dir != null) {
					          // Set the text box to the new selection
					        	MFtext.setText(dir);
					        	
					        	if(Commons.A1C.checkFileExist(MFtext.getText()))
					        	{
					        		//controllo prima che il file settato in ME non sia lo stesso
					        		boolean esci=false;
					        		if(Commons.ME!=null && Commons.ME.getAbsolutePath().compareTo(MFtext.getText())==0)
					        		{
					        			int risp=printAlertYesNo(Commons.ALERT3);
					        			if(risp==SWT.YES)
					        			{
					        				Commons.ME=null;
					        				MEtext.setText("");
					        			}
					        			else
					        			{
					        				//ESCI
					        				esci=true;
					        				MFtext.setText("");
					        				Commons.MF=null;
					        			}
					        	    }
				
					        		if(!esci)
					        		{
					        		//se il file esiste richiedi sovrascrittura
					        		int risp=printAlertYesNo(Commons.ALERT1);
					        		if(risp==SWT.YES)
					        		{
					        			//sovrascrittura autorizzata
					        			Commons.A1C.loadFile(MFtext.getText(),"MF");
					        		}
					        		else
					        		{
					        			//sovrascrittura non autorizzata
					        			//scegli un altro file
					        			printAlert(Commons.ALERT2);
					        			MFtext.setText("");
					        		}
					        		
					        		}//esci
					        	}
					        }  
				}

					
				});
		labelME = new Label(OutputGroup, SWT.NONE);
		labelME.setText("ME:");
		labelME.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		MEtext = new Text(OutputGroup, SWT.BORDER);
		MEtext.setLayoutData(gridData9);
		MEtext.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				Commons.ME=null;}
		});
		BrowseMEbutton = new Button(OutputGroup, SWT.NONE);
		BrowseMEbutton.setText("Browse");
		BrowseMEbutton.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD | SWT.ITALIC));
		BrowseMEbutton
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						System.out.println("BROWSE OUTPUT ME"); // TODO Auto-generated Event stub widgetSelected()
					MEtext.setText("");
					Commons.ME=null;
						FileDialog dlg = new FileDialog(sShell);
					        // Set the initial filter path according
					        // to anything they've selected or typed in
					        dlg.setFilterPath(MEtext.getText());
					        // Change the title bar text
					        dlg.setText("Select Output ME File");
					        // Calling open() will open and run the dialog.
					        // It will return the selected directory, or
					        // null if user cancels
					        String dir = dlg.open();
					        if (dir != null) {
					          // Set the text box to the new selection
					        	MEtext.setText(dir);
					        	
					        	
					        	if(Commons.A1C.checkFileExist(MEtext.getText()))
					        	{
					        		//controllo prima che il file settato in ME non sia lo stesso
					        		boolean esci=false;
					        		if(Commons.MF!=null && Commons.MF.getAbsolutePath().compareTo(MEtext.getText())==0)
					        		{
					        			int risp=printAlertYesNo(Commons.ALERT3);
					        			if(risp==SWT.YES)
					        			{
					        				Commons.MF=null;
					        				MFtext.setText("");
					        			}
					        			else
					        			{
					        				//ESCI
					        				esci=true;
					        				MEtext.setText("");
					        				Commons.ME=null;
					        			}
					        	    }
					        	
					        		if(!esci)
					        		{
					        		//se il file esiste richiedi sovrascrittura
					        		int risp=printAlertYesNo(Commons.ALERT1);
					        		if(risp==SWT.YES)
					        		{
					        			//sovrascrittura autorizzata
					        			Commons.A1C.loadFile(MEtext.getText(),"ME");
					        		}
					        		else
					        		{
					        			//sovrascrittura non autorizzata
					        			//scegli un altro file
					        			printAlert(Commons.ALERT2);
					        			MEtext.setText("");
					        		}
					        		
					        		}
					        	}
					    
					        } 
					      }
				});
	}
	/**
	 * This method initializes group	
	 *
	 */
	private void createGroup() {
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.CENTER;
		gridData11.grabExcessHorizontalSpace = true;
		gridData11.grabExcessVerticalSpace = true;
		gridData11.verticalAlignment = GridData.FILL;
		GridData gridData10 = new GridData();
		gridData10.horizontalAlignment = GridData.FILL;
		gridData10.grabExcessHorizontalSpace = true;
		gridData10.grabExcessVerticalSpace = false;
		gridData10.verticalAlignment = GridData.CENTER;
		group = new Group(A1group, SWT.NONE);
		group.setLayout(new GridLayout());
		group.setLayoutData(gridData10);
		A1button = new Button(group, SWT.NONE);
		A1button.setText("RUN A1");
		A1button.setFont(new Font(Display.getDefault(), "Segoe UI", 10, SWT.BOLD));
		A1button.setLayoutData(gridData11);
		A1button.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				System.out.println("RUN A1"); // TODO Auto-generated Event stub widgetSelected()
			
				boolean checkMF=verificaFileMF();
							
				boolean checkME=verificaFileME();
				
				if(checkMF && checkME)
				{
					if(Commons.fV.size()>0)	
						{
						Commons.A1C.loadFile(MFtext.getText(), "MF");
						Commons.A1C.loadFile(MEtext.getText(), "ME");
						
						Commons.A1C.runA1();
						}
					else printAlert(Commons.ALERT7);
				}
			}
		});
	}
	
	public boolean verificaFileMF()
	{
		boolean checkMF=true;
		
//		controllo che il file in MF sia settato
		if(Commons.MF==null)
		{
			if(MFtext.getText().trim().compareTo("")==0)
			{
				System.out.println("File MF non settato");
				printAlert("MF: "+Commons.ALERT4);
				checkMF=false;
			}
			else
			{
				//setta MF
				if(Commons.A1C.checkFileExist(MFtext.getText()))
				{
					
//					controllo prima che il file settato in ME non sia lo stesso
	        		boolean esci=false;
	        		if(Commons.ME!=null && Commons.ME.getAbsolutePath().compareTo(MFtext.getText())==0)
	        		{
	        			int risp=printAlertYesNo(Commons.ALERT3);
	        			if(risp==SWT.YES)
	        			{
	        				Commons.ME=null;
	        				MEtext.setText("");
	        				Commons.A1C.loadFile(MFtext.getText(), "MF");
	        			}
	        			else
	        			{
	        				//ESCI
	        				esci=true;
	        				MFtext.setText("");
	        				Commons.MF=null;
	        				checkMF=false;
	        			}
	        	    }

					if(!esci){
					//il file gi esiste chiedi sovrascrittura
					int risp=printAlertYesNo(Commons.ALERT1);
        			if(risp==SWT.YES)
        			{
        				Commons.A1C.loadFile(MFtext.getText(), "MF");
        			}
        			else
        			{
        				//scegli un altro file
        				checkMF=false;
        				MFtext.setText("");
        				Commons.MF=null;
        				printAlert(Commons.ALERT2);
        			}
				  }	
				}//il file esiste
				else
				{
					//verifica Path
					File temp=new File(MFtext.getText());
				    if(new File(temp.getParent()).isDirectory())
				    {
				    	//il file va bene
				    	Commons.A1C.loadFile(MFtext.getText(), "MF");
				    }
				    else
				    {
				    	//il path  inesistente
				    	printAlert("MF: " +Commons.ALERT5);
				    	MFtext.setText("");
				    	Commons.MF=null;
				    	checkMF=false;
				    }
				}
			 		
			}//testo nella casella MF
		}

		return checkMF;
	}
	
	public boolean verificaFileME()
	{
		boolean checkME=true;
		
//		controllo che il file in MF sia settato
		if(Commons.ME==null)
		{
			if(MEtext.getText().trim().compareTo("")==0)
			{
				System.out.println("File ME non settato");
				printAlert("ME: "+Commons.ALERT4);
				checkME=false;
				Commons.ME=null;
			}
			else
			{
				//setta ME
				if(Commons.A1C.checkFileExist(MEtext.getText()))
				{
					
//					controllo prima che il file settato in MF non sia lo stesso
	        		boolean esci=false;
	        		if(Commons.MF!=null && Commons.MF.getAbsolutePath().compareTo(MEtext.getText())==0)
	        		{
	        			int risp=printAlertYesNo(Commons.ALERT3);
	        			if(risp==SWT.YES)
	        			{
	        				Commons.MF=null;
	        				MFtext.setText("");
	        				Commons.A1C.loadFile(MEtext.getText(), "ME");

	        			}
	        			else
	        			{
	        				//ESCI
	        				esci=true;
	        				MEtext.setText("");
	        				Commons.ME=null;
	        				checkME=false;
	        			}
	        	    }

					if(!esci){
					//il file gi esiste chiedi sovrascrittura
					int risp=printAlertYesNo(Commons.ALERT1);
        			if(risp==SWT.YES)
        			{
        				Commons.A1C.loadFile(MEtext.getText(), "ME");
        			}
        			else
        			{
        				//scegli un altro file
        				checkME=false;
        				MEtext.setText("");
        				Commons.ME=null;
        				printAlert(Commons.ALERT2);
        			}
				  }	
				}//il file esiste
				else
				{
					//verifica Path
					File temp=new File(MEtext.getText());
				    if(new File(temp.getParent()).isDirectory())
				    {
				    	//il file va bene
				    	Commons.A1C.loadFile(MEtext.getText(), "ME");
				    }
				    else
				    {
				    	//il path  inesistente
				    	printAlert("ME: " +Commons.ALERT5);
				    	MEtext.setText("");
				    	Commons.ME=null;
				    	checkME=false;
				    }
				}
			 		
			}//testo nella casella MF
		}

		return checkME;
	}
	
	public int printAlertYesNo(String mex)
	{
		MessageBox b=new MessageBox(sShell,SWT.YES|SWT.NO);
		b.setMessage(mex);
		if(b.open()==SWT.YES)
		{
			//SCELTO SI NELLA FINESTRA
			return SWT.YES;
		}
		else
		{
			//SCELTO NO NELLA FINESTRA
			return SWT.NO;
		}
	}
	
	public void printAlert(String mex)
	{
		MessageBox b=new MessageBox(sShell);
		b.setMessage(mex);
		b.open();
	}
	/**
	 * This method initializes groupFileInput	
	 *
	 */
	private void createGroupFileInput() {
		GridData gridData12 = new GridData();
		gridData12.horizontalAlignment = GridData.FILL;
		gridData12.grabExcessHorizontalSpace = true;
		gridData12.grabExcessVerticalSpace = false;
		gridData12.verticalAlignment = GridData.CENTER;
		groupFileInput = new Group(composite, SWT.NONE);
		groupFileInput.setLayout(new GridLayout());
		createINputgroup();
		groupFileInput.setLayoutData(gridData12);
	}
	/**
	 * This method initializes Inputgroup1	
	 *
	 */
	private void createInputgroup1() {
		GridData gridData15 = new GridData();
		gridData15.horizontalAlignment = GridData.FILL;
		gridData15.grabExcessHorizontalSpace = true;
		gridData15.verticalAlignment = GridData.CENTER;
		GridData gridData14 = new GridData();
		gridData14.horizontalAlignment = GridData.FILL;
		gridData14.grabExcessHorizontalSpace = true;
		gridData14.verticalAlignment = GridData.CENTER;
		GridData gridData13 = new GridData();
		gridData13.horizontalSpan = 2;
		GridLayout gridLayout3 = new GridLayout();
		gridLayout3.numColumns = 2;
		Inputgroup1 = new Group(A2group, SWT.NONE);
		Inputgroup1.setText("Input");
		Inputgroup1.setLayoutData(gridData14);
		Inputgroup1.setLayout(gridLayout3);
		label2 = new Label(Inputgroup1, SWT.NONE);
		label2.setText("Selezionare File FREF");
		label2.setLayoutData(gridData13);
		label2.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		FREFtext = new Text(Inputgroup1, SWT.BORDER);
		FREFtext.setLayoutData(gridData15);
		FREFtext.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				Commons.FREF=null;
				}
		});
		FREFbutton = new Button(Inputgroup1, SWT.NONE);
		FREFbutton.setText("Browse FREF");
		FREFbutton.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD | SWT.ITALIC));
		FREFbutton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				System.out.println("BROWSE FREF"); // TODO Auto-generated Event stub widgetSelected()
				Commons.FREF=null;
				FREFtext.setText("");
				FileDialog dlg = new FileDialog(sShell);
			        // Set the initial filter path according
			        // to anything they've selected or typed in
			        dlg.setFilterPath(FREFtext.getText());
			        // Change the title bar text
			        dlg.setText("Select FREF File");
			        // Calling open() will open and run the dialog.
			        // It will return the selected directory, or
			        // null if user cancels
			        String dir = dlg.open();
			        if (dir != null) {
			          // Set the text box to the new selection
			        	FREFtext.setText(dir);
			        	if(Commons.A2C.checkFileExist(FREFtext.getText()))
			        	{
			        		Commons.A2C.loadFile(FREFtext.getText(), "FREF");
			        	}
			        }
			        }
		});
	}
	/**
	 * This method initializes Outputgroup1	
	 *
	 */
	private void createOutputgroup1() {
		GridData gridData18 = new GridData();
		gridData18.horizontalAlignment = GridData.BEGINNING;
		gridData18.grabExcessHorizontalSpace = false;
		gridData18.horizontalSpan = 2;
		gridData18.verticalAlignment = GridData.CENTER;
		GridData gridData17 = new GridData();
		gridData17.horizontalAlignment = GridData.FILL;
		gridData17.grabExcessHorizontalSpace = true;
		gridData17.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout4 = new GridLayout();
		gridLayout4.numColumns = 2;
		GridData gridData16 = new GridData();
		gridData16.horizontalAlignment = GridData.FILL;
		gridData16.grabExcessHorizontalSpace = true;
		gridData16.verticalAlignment = GridData.CENTER;
		Outputgroup1 = new Group(A2group, SWT.NONE);
		Outputgroup1.setLayoutData(gridData16);
		Outputgroup1.setLayout(gridLayout4);
		Outputgroup1.setText("Output");
		label3 = new Label(Outputgroup1, SWT.NONE);
		label3.setText("Selezionare file N");
		label3.setLayoutData(gridData18);
		label3.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		Ntext = new Text(Outputgroup1, SWT.BORDER);
		Ntext.setLayoutData(gridData17);
		Ntext.addModifyListener(new org.eclipse.swt.events.ModifyListener() {
			public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
				Commons.N=null;
				}
		});
		Nbutton = new Button(Outputgroup1, SWT.NONE);
		Nbutton.setText("Browse N");
		Nbutton.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD | SWT.ITALIC));
		Nbutton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				System.out.println("BROWSE N"); // TODO Auto-generated Event stub widgetSelected()
				Commons.N=null;
				Ntext.setText("");
				FileDialog dlg = new FileDialog(sShell);
			        // Set the initial filter path according
			        // to anything they've selected or typed in
			        dlg.setFilterPath(Ntext.getText());
			        // Change the title bar text
			        dlg.setText("Select N File");
			        // Calling open() will open and run the dialog.
			        // It will return the selected directory, or
			        // null if user cancels
			        String dir = dlg.open();
			        if (dir != null) {
			          // Set the text box to the new selection
			        	Ntext.setText(dir);
			        	////////////
			        	
			        	if(Commons.A2C.checkFileExist(Ntext.getText()))
			        	{
			        		
			        		//se il file esiste richiedi sovrascrittura
			        		int risp=printAlertYesNo(Commons.ALERT1);
			        		if(risp==SWT.YES)
			        		{
			        			//sovrascrittura autorizzata
			        			Commons.A2C.loadFile(Ntext.getText(),"N");
			        		}
			        		else
			        		{
			        			//sovrascrittura non autorizzata
			        			//scegli un altro file
			        			printAlert(Commons.ALERT2);
			        			Ntext.setText("");
			        		}
			        		
			        	}		
			        	
			        	
			        	//////////
			        }
			   }
		});
	}
	/**
	 * This method initializes group1	
	 *
	 */
	private void createGroup1() {
		GridData gridData20 = new GridData();
		gridData20.horizontalAlignment = GridData.CENTER;
		gridData20.grabExcessHorizontalSpace = true;
		gridData20.verticalAlignment = GridData.CENTER;
		GridData gridData19 = new GridData();
		gridData19.horizontalAlignment = GridData.FILL;
		gridData19.grabExcessHorizontalSpace = true;
		gridData19.grabExcessVerticalSpace = false;
		gridData19.verticalAlignment = GridData.CENTER;
		group1 = new Group(A2group, SWT.NONE);
		group1.setLayout(new GridLayout());
		group1.setLayoutData(gridData19);
		RUNA2button = new Button(group1, SWT.NONE);
		RUNA2button.setText("RUN A2");
		RUNA2button.setLayoutData(gridData20);
		RUNA2button.setFont(new Font(Display.getDefault(), "Segoe UI", 10, SWT.BOLD));
		RUNA2button.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				System.out.println("RUN A2"); // TODO Auto-generated Event stub widgetSelected()
				
				boolean checkFREF=verificaFileFREF();
				boolean checkN=verificaFileN();
				
				if(checkFREF && checkN)
				{
					if(Commons.fV.size()>0)	
						{
						Commons.A2C.loadFile(FREFtext.getText(), "FREF");
						Commons.A2C.loadFile(Ntext.getText(), "N");
						
						Commons.A2C.runA2();
						}
					else printAlert(Commons.ALERT7);
				}
				}
		});
	}
	
	
	
	public boolean verificaFileN()
	{
		boolean checkN=true;
		
//		controllo che il file in MF sia settato
		if(Commons.N==null)
		{
			if(Ntext.getText().trim().compareTo("")==0)
			{
				System.out.println("File N non settato");
				printAlert("N: "+Commons.ALERT4);
				checkN=false;
			}
			else
			{
				//setta ME
				if(Commons.A2C.checkFileExist(Ntext.getText()))
				{
					//il file gi esiste chiedi sovrascrittura
					int risp=printAlertYesNo(Commons.ALERT1);
        			if(risp==SWT.YES)
        			{
        				Commons.A2C.loadFile(Ntext.getText(), "N");
        			}
        			else
        			{
        				//scegli un altro file
        				checkN=false;
        				Ntext.setText("");
        				Commons.N=null;
        				printAlert(Commons.ALERT2);
        			}
				}//il file esiste
				else
				{
					//verifica Path
					File temp=new File(Ntext.getText());
				    if(new File(temp.getParent()).isDirectory())
				    {
				    	//il file va bene
				    	Commons.A2C.loadFile(Ntext.getText(), "N");
				    }
				    else
				    {
				    	//il path  inesistente
				    	printAlert("N: " +Commons.ALERT5);
				    	Ntext.setText("");
				    	Commons.N=null;
				    	checkN=false;
				    }
				}
			 		
			}//testo nella casella MF
		}

		return checkN;
	}
	
	
	public boolean verificaFileFREF()
	{
		boolean checkFREF=true;
		
//		controllo che il file in FREF sia settato
		if(Commons.FREF==null)
		{
			if(FREFtext.getText().trim().compareTo("")==0)
			{
				System.out.println("File FREF non settato");
				printAlert("FREF: "+Commons.ALERT4);
				checkFREF=false;
			}
			else
			{
				//setta ME
				if(Commons.A2C.checkFileExist(FREFtext.getText()))
				{
					
				}//il file esiste
				else
				{
					checkFREF=false;
					FREFtext.setText("");
					Commons.FREF=null;
					printAlert("FREF: "+Commons.ALERT5);
				}
			 		
			}//testo nella casella MF
		}

		return checkFREF;
	}
	
}
